给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
python3:有两种解法:1.暴力遍历 2.哈希表
1.暴力遍历:时间复杂度:o(n^2).空间o(1)
class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
n = len(nums)
for i in range(0, n):
for j in range(i+1, n):
if nums[i] + nums[j] == target:
return [i, j]
return []
2.哈希表:时间复杂度:o(N),空间o(N).hashtavble:{值:索引}
class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
n = len(nums)
hashtable = dict()
for i,vale in enumerate(nums)
a = target - value
if a in hashtable:
return [hashtable[a], i]
hashtable[a] = i
return []
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。